<div class="btnAcrossPageName">
    <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='PRIMARY'
               (click)="save(constant.STATUS_OBJ.IS_DECLARING)"
               *ngIf="!isDetail"
               mbButtonText="{{'selfService.dependentRegisters.save' | translate}}"></mb-button>
    <mb-button
        *ngIf="!isDetail"
        (click)="save(constant.STATUS_OBJ.WAIT_APPROVE)"
        [mbButtonAvailableStyle]="'PRIMARY'"
        mbButtonText="{{'selfService.dependentRegisters.sendBrowsing' | translate}}"
    ></mb-button>

    <mb-button
        (click)="onBack()"
        *ngIf="!isDetail"
        [mbButtonAvailableStyle]="'CANCEL'"
        mbButtonText="{{'common.button.cancel' | translate}}"
    ></mb-button>
    <mb-button
        (click)="onBack()"
        *ngIf="isDetail"
        [mbButtonAvailableStyle]="'CANCEL'"
        mbButtonText="{{'selfService.dependentRegisters.back' | translate}}"
    ></mb-button>
</div>


<div class='content__item content__item--border bg__content--default'>
  <app-loading *ngIf="isLoadingPage"></app-loading>
  <app-personal-information
      (employeeInfoEvent)="getEmployeeInfo($event)"
  ></app-personal-information>
  <form nz-form [formGroup]="form" style="margin-top: 20px">
    <div nz-row [nzGutter]="[30,30]">
      <div nz-col [nzXs]="12" [nzLg]="8">
        <mb-select [mbDataSelects]="listRelatives"
                   formControlName="familyRelationshipId"
                   (mbEventSelect)="changeRelatives($event)"
                   [mbType]="isSubmitted && form.controls['familyRelationshipId'].errors ? 'error' : 'default'"
                   [mbShowError]="isSubmitted && form.controls['familyRelationshipId'].errors !== null"
                   [mbErrors]="form.controls['familyRelationshipId'].errors"
                   [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.dependentName' | translate }}]"
                   mbPlaceholder="{{'selfService.dependentRegisters.dependentName' | translate}}"
                   mbLabelText="{{'selfService.dependentRegisters.dependentName' | translate}} <span class='label__required'>*</span>"
        ></mb-select>
      </div>
      <div nz-col [nzXs]="12" [nzLg]="8">
        <mb-date-picker
          formControlName="dateOfBirth"
          (ngModelChange)="changeDateOfBirth($event)"
          mbLabelText="{{'selfService.dependentRegisters.dateOfBirth' | translate}}"
          mbPlaceholderText="{{'selfService.dependentRegisters.dateOfBirth' | translate}}"
        ></mb-date-picker>
      </div>
      <div nz-col nzXs="12" nzLg="8" *ngIf="isDetail">
        <mb-input-text
          mbPlaceholderText="{{'selfService.dependentRegisters.dependentAge' | translate}}"
          mbLabelText="{{'selfService.dependentRegisters.dependentAge' | translate}}"
          formControlName="dependentAge"></mb-input-text>
      </div>
    </div>
    <div nz-row [nzGutter]="[30,30]">
      <div nz-col [nzXs]="24" [nzLg]="24" style="display: flex; align-items: center; margin: 15px 0">
        <nz-switch [nzDisabled]="isDisabledCheckIdNo" formControlName="isHaveIdNo" (ngModelChange)="checkIsIdNo($event)"></nz-switch>
        <span style="margin-left: 10px">{{'selfService.dependentRegisters.haveIdNo' | translate}}</span>
      </div>
    </div>
    <div nz-row [nzGutter]="[30,30]">
      <ng-container *ngIf="form.controls.isHaveIdNo.value">
        <div nz-col [nzXs]="12" [nzLg]="6">
          <mb-input-text
            formControlName="taxNo"
            [mbMaxLength]="10"
            appNumberInput
            [mbType]="isSubmitted && form.controls['taxNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['taxNo'].errors !== null"
            [mbErrors]="form.controls['taxNo'].errors"
            [mbErrorDefs]="[
              { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.idNoOrTaxNo' | translate }},
              { errorName: 'minlength', errorDescription: 'selfService.validate.taxNoError' | translate},
              { errorName: 'maxlength', errorDescription: 'selfService.validate.taxNoError' | translate}
            ]"
            mbPlaceholderText="{{'selfService.dependentRegisters.taxNo' | translate}}"
            mbLabelText="{{'selfService.dependentRegisters.taxNo' | translate}}"></mb-input-text>
        </div>
        <div nz-col [nzXs]="12" [nzLg]="6">
          <mb-input-text
            formControlName="idNo"
            [mbMaxLength]="12"
            appNumberInput
            [mbType]="(isSubmitted && form.controls['idNo'].errors || form.errors?.onlyAccept9Or12Digit) ? 'error' : 'default'"
            [mbShowError]="(isSubmitted && (form.controls['idNo'].errors !== null || form.errors?.onlyAccept9Or12Digit !== null))"
            [mbErrors]="form.errors?.onlyAccept9Or12Digit ? form.errors : form.controls['idNo'].errors"
            [mbErrorDefs]="[
                { errorName: 'required', errorDescription: 'selfService.dependentRegisters.requiredIdNo' | translate},
                { errorName: 'onlyAccept9Or12Digit', errorDescription: 'selfService.validate.onlyAccept9Or12Digit' | translate: {'param': 'selfService.dependentRegisters.idNo' | translate}}
            ]"
            mbPlaceholderText="{{'selfService.dependentRegisters.idNo' | translate}}"
            mbLabelText="{{'selfService.dependentRegisters.idNo' | translate}}"></mb-input-text>
        </div>
      </ng-container>
      <ng-container *ngIf="!form.controls.isHaveIdNo.value">
        <div nz-col [nzXs]="12" [nzLg]="12">
          <mb-input-text
            formControlName="codeNo"
            [mbMaxLength]="20"
            [mbType]="isSubmitted && form.controls['codeNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['codeNo'].errors !== null"
            [mbErrors]="form.controls['codeNo'].errors"
            [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.codeNo' | translate }}]"
            mbPlaceholderText="{{'selfService.dependentRegisters.codeNo' | translate}}"
            mbLabelText="{{'selfService.dependentRegisters.codeNo' | translate}} <span class='label__required'>*</span>"></mb-input-text>
        </div>
        <div nz-col [nzXs]="12" [nzLg]="12">
          <mb-input-text
            formControlName="bookNo"
            [mbMaxLength]="20"
            [mbType]="isSubmitted && form.controls['bookNo'].errors ? 'error' : 'default'"
            [mbShowError]="isSubmitted && form.controls['bookNo'].errors !== null"
            [mbErrors]="form.controls['bookNo'].errors"
            [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.bookNo' | translate }}]"
            mbPlaceholderText="{{'selfService.dependentRegisters.bookNoNote' | translate}}"
            mbLabelText="{{'selfService.dependentRegisters.bookNo' | translate}} <span class='label__required'>*</span>"></mb-input-text>
        </div>
        <div nz-col [nzXs]="12" [nzLg]="6">
          <mb-select [mbDataSelects]="nations"
                     formControlName="nationCode"
                     [mbType]="isSubmitted && form.controls['nationCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['nationCode'].errors !== null"
                     [mbErrors]="form.controls['nationCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.nationCode' | translate }}]"
                     mbPlaceholder="{{'selfService.dependentRegisters.nationCode' | translate}}"
                     mbLabelText="{{'selfService.dependentRegisters.nationCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
        <div nz-col [nzXs]="12" [nzLg]="6">
          <mb-select [mbDataSelects]="provinces"
                     formControlName="provinceCode"
                     (mbEventEmit)="changeProvince($event)"
                     [mbType]="isSubmitted && form.controls['provinceCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['provinceCode'].errors !== null"
                     [mbErrors]="form.controls['provinceCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.provinceCode' | translate }}]"
                     mbPlaceholder="{{'selfService.dependentRegisters.provinceCode' | translate}}"
                     mbLabelText="{{'selfService.dependentRegisters.provinceCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
        <div nz-col [nzXs]="12" [nzLg]="6">
          <mb-select [mbDataSelects]="districts"
                     formControlName="districtCode"
                     (mbEventEmit)="changeDistrict($event)"
                     [mbType]="isSubmitted && form.controls['districtCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['districtCode'].errors !== null"
                     [mbErrors]="form.controls['districtCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.districtCode' | translate }}]"
                     mbPlaceholder="{{'selfService.dependentRegisters.districtCode' | translate}}"
                     mbLabelText="{{'selfService.dependentRegisters.districtCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
        <div nz-col [nzXs]="12" [nzLg]="6">
          <mb-select [mbDataSelects]="wards"
                     formControlName="wardCode"
                     [mbType]="isSubmitted && form.controls['wardCode'].errors ? 'error' : 'default'"
                     [mbShowError]="isSubmitted && form.controls['wardCode'].errors !== null"
                     [mbErrors]="form.controls['wardCode'].errors"
                     [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.wardCode' | translate }}]"
                     mbPlaceholder="{{'selfService.dependentRegisters.wardCode' | translate}}"
                     mbLabelText="{{'selfService.dependentRegisters.wardCode' | translate}} <span class='label__required'>*</span>"
          ></mb-select>
        </div>
      </ng-container>
      <div nz-col [nzXs]="12" [nzLg]="6">
        <mb-date-picker
          mbPlaceholderText="{{'selfService.dependentRegisters.fromDate' | translate}}"
          mbLabelText="{{'selfService.dependentRegisters.fromDate' | translate}} <span class='label__required'>*</span>"
          mbMode="month"
          [mbFormat]="'MM/yyyy'"
          [mbType]="isSubmitted && (form.errors || form.controls['fromDate'].errors) ? 'error' : 'default'"
          [mbShowError]="isSubmitted && (form.errors || form.controls['fromDate'].errors ) !== null"
          [mbErrors]="form.errors?.rangeDateError ? form.errors : form.controls['fromDate'].errors"
          [mbErrorDefs]="[{ errorName: 'rangeDateError', errorDescription: 'selfService.validate.rangeDate.pareDate' | translate:
        {'fromDate': 'selfService.dependentRegisters.fromDate' | translate, 'toDate': 'selfService.dependentRegisters.toDate' | translate}},
             { errorName: 'required', errorDescription: 'selfService.validate.required' | translate: {'param': 'selfService.dependentRegisters.fromDate' | translate }}
          ]"
          formControlName="fromDate"></mb-date-picker>
      </div>
      <div nz-col [nzXs]="12" [nzLg]="6">
        <mb-date-picker
          mbPlaceholderText="{{'selfService.dependentRegisters.toDate' | translate}}"
          mbLabelText="{{'selfService.dependentRegisters.toDate' | translate}}"
          mbMode="month"
          [mbFormat]="'MM/yyyy'"
          formControlName="toDate"></mb-date-picker>
      </div>

      <div nz-col nzXs=24 nzLg="24" *ngIf="isDetail && (status === constant.STATUS_OBJ.FINANCIAL_ACCOUNTANT_RETURN || status === constant.STATUS_OBJ.TAX_AUTHORITIES_RETURN)">
        <mb-input-text
          formControlName="rejectReason"
          [mbIsTextAre]="true"
          mbLabelText="{{'personalTax.taxRegisters.rejectReason' | translate}}"></mb-input-text>
      </div>

      <div nz-col [nzXs]=24 [nzLg]="24">
        <mb-input-text
          formControlName="note"
          [mbIsTextAre]="true"
          [mbMaxLength]="500"
          mbPlaceholderText="{{'selfService.dependentRegisters.note' | translate}}"
          mbLabelText="{{'selfService.dependentRegisters.note' | translate}}"></mb-input-text>
      </div>
      <div nz-col [nzXs]='24' [nzLg]='20' class="input__group">
        <label class="input__label">{{'selfService.label.file' | translate}}  <span class='label__required'>*</span></label>
        <span class="uploadHintText">{{'selfService.taxRegisters.uploadHintText' | translate}}</span>

        <div class="uploadFile--wrap">
          <nz-upload
            [nzMultiple]=" true"
            [(nzFileList)]="fileList"
            [nzBeforeUpload]="beforeUpload"
            [nzRemove]="removeFile"
            [nzDownload]="downloadFile"
            nzAccept=".TIF, .JPG, .GIF, .PNG, .PDF, .DOC, .DOCX, .XLS, .XLSX"
          >
            <button class="btnUploadFile">{{'selfService.taxRegisters.btnUploadFile' | translate}}</button>
          </nz-upload>
        </div>
        <div *ngIf="isSubmitted && this.fileList?.length === 0" class="input__group">
          <div class="input__message">
            <em nz-icon nzType="close-circle" nzTheme="outline"></em>
            <span class="text__message">{{'selfService.validate.fileRequired' | translate}}</span>
          </div>
        </div>
      </div>
    </div>
  </form>
</div>
